﻿using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_RowLayoutSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DisplayLayout.Override.AllowColMoving = AllowColMoving.WithinBand;
            ultraGrid1.DisplayLayout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
        }


        private void ultraButton1_Click(object sender, EventArgs e)
        {
            UltraGridColumn colToBeMoved = ultraGrid1.DisplayLayout.Bands[0].Columns[(int)ultraNumericEditor1.Value];
            UltraGridColumn colToBeReplaced = ultraGrid1.DisplayLayout.Bands[0].Columns[(int)ultraNumericEditor2.Value];

            int beginningOrigin = colToBeMoved.RowLayoutColumnInfo.OriginX;
            int endingOrigin = colToBeReplaced.RowLayoutColumnInfo.OriginX;
            int offset = colToBeMoved.RowLayoutColumnInfo.SpanX;

            if (beginningOrigin == (endingOrigin - 1) || colToBeMoved == colToBeReplaced)
            {
                //Exits if the origins won't change the grid column layout
                return;
            }

            foreach (var col in ultraGrid1.DisplayLayout.Bands[0].Columns)
            {
                if (beginningOrigin > endingOrigin && col != colToBeMoved)
                {
                    //Logic for moving the columns to the left
                    if (beginningOrigin >= col.RowLayoutColumnInfo.OriginX
                             && endingOrigin <= col.RowLayoutColumnInfo.OriginX)
                    {
                        col.RowLayoutColumnInfo.OriginX += offset;
                    }
                }
                else
                {
                    //Logic for moving the columns to the right
                    if (endingOrigin <= col.RowLayoutColumnInfo.OriginX)
                    {
                        col.RowLayoutColumnInfo.OriginX += offset;
                    }
                }
            }
            colToBeMoved.RowLayoutColumnInfo.OriginX = endingOrigin;
            
        }

    }
}
